#!/usr/bin/env python3

inp = []
WIDTH = 8
HEIGHT = 8

with open('vstup.txt') as f:
    for line in f:
        inp.append(line)

remain = int(inp[0])
field = inp[1:]
for i in range(len(field)):
    field[i] = [int(x) for x in field[i] if x != '\n']

# print(remain)
# for y in range(HEIHGT):
#     for x in range(WIDTH):
#         print(field[y][x], end='')
#     print()

# Approximate gained points in the round
def search():
    triples = [] # [x start, y start, 0=horizontal/1=vertical]

    for y in range(HEIGHT):
        for x in range(WIDTH):
            if x < WIDTH - 2 and field[y][x] == field[y][x+1] and field[y][x] == field[y][x+2]:
                triples.append([x, y, 0])
            if y < HEIGHT - 2 and field[y][x] == field[y+1][x] and field[y][x] == field[y+2][x]:
                triples.append([x, y, 1])
    return len(triples)*3

# Search the field for possible moves
max_score = [0]
for y in range(HEIGHT - 1):
    for x in range(WIDTH - 1):
        cache = field[y][x]

        # Horizontal
        field[y][x] = field[y][x+1]
        field[y][x+1] = cache
        # Evaluate and save if the best
        score = search()
        if score > max_score[0]:
            max_score = [score, x+1, y+1, x+2, y+1]
        field[y][x+1] = field[y][x]
        field[y][x] = cache

        # Vertical
        field[y][x] = field[y+1][x]
        field[y+1][x] = cache
        # Evaluate and save if the best
        score = search()
        if score > max_score[0]:
            max_score = [score, x+1, y+1, x+1, y+2]
        field[y+1][x] = field[y][x]
        field[y][x] = cache

# print(max_score)

with open('vystup.txt', 'w') as f:
    f.write(' '.join([str(x) for x in max_score[1:]]))
